package handler

import (
	"fmt"
	"net/http"
	"net/url"

	"github.com/gorilla/mux"

	"gosimplenpm/storage"
)

func Get(w http.ResponseWriter, r *http.Request) {
	escapedName := mux.Vars(r)["name"]
	packageName, _ := url.PathUnescape(escapedName)
	fmt.Printf("Package name => %s\n", packageName)

	fileToServe, found, err := storage.GetIndexJsonFromStore(packageName)
	if err != nil {
		http.Error(w, err.Error(), http.StatusInternalServerError)
		return
	}

	if !found {
		ret := fmt.Sprintf("Package not found: %s", packageName)
		http.Error(w, ret, http.StatusNotFound)
		return
	}

	// serve file
	http.ServeFile(w, r, fileToServe)
}
