package serviceidos

type IndexJsonAttachments struct {
	ContentType string `json:"content_type"`
	Data        string `json:"data"`
	Length      int    `json:"length"`
}

type IndexJsonDist struct {
	Integrity string `json:"integrity"`
	Shasum    string `json:"shasum"`
	Tarball   string `json:"tarball"`
}

type IndexJsonVersions struct {
	Name            string            `json:"name"`
	Version         string            `json:"version"`
	Description     string            `json:"description"`
	Main            string            `json:"main,omitempty"`
	Scripts         map[string]string `json:"scripts,omitempty"`
	Author          string            `json:"author,omitempty"`
	License         string            `json:"license"`
	Files           []string          `json:"files"`
	Readme          string            `json:"readme,omitempty"`
	ID              string            `json:"_id"`
	NodeVersion     string            `json:"_nodeVersion"`
	NpmVersion      string            `json:"_npmVersion"`
	Dist            IndexJsonDist     `json:"dist"`
	Dependencies    map[string]string `json:"dependencies,omitempty"`
	DevDependencies map[string]string `json:"devDependencies,omitempty"`
	Resolutions     map[string]string `json:"resolutions,omitempty"`
}

type IndexJson struct {
	ID          string                          `json:"_id"`
	Name        string                          `json:"name"`
	Description string                          `json:"description"`
	DistTags    map[string]string               `json:"dist-tags"`
	Versions    map[string]IndexJsonVersions    `json:"versions"`
	Access      string                          `json:"access"`
	Attachments map[string]IndexJsonAttachments `json:"_attachments"`
}
